CodeForces - 923B Producing Snow(思维!!! 优先队列 + 前缀和)

Producing Snow

Alice likes snow a lot! Unfortunately, this year's winter is already over, and she can't expect to have any more of it. Bob has thus bought her a gift — a large snow maker. He plans to make some amount of snow every day. On day i he will make a pile of snow of volume Vi and put it in her garden.

Each day, every pile will shrink a little due to melting. More precisely, when the temperature on a given day is Ti, each pile will reduce its volume by Ti. If this would reduce the volume of a pile to or below zero, it disappears forever. All snow piles are independent of each other.

Note that the pile made on day i already loses part of its volume on the same day. In an extreme case, this may mean that there are no piles left at the end of a particular day.

You are given the initial pile sizes and the temperature on each day. Determine the total volume of snow melted on each day.

Input

The first line contains a single integer N (1 ≤ N ≤ 105) — the number of days.

The second line contains N integers V1, V2, ..., VN (0 ≤ Vi ≤ 109), where Vi is the initial size of a snow pile made on the day i.

The third line contains N integers T1, T2, ..., TN (0 ≤ Ti ≤ 109), where Ti is the temperature on the day i.

Output

Output a single line with N integers, where the i-th integer represents the total volume of snow melted on day i.

Examples

Input

3
10 10 5
5 7 2

Output

5 12 4

Input

5
30 25 20 15 10
9 10 12 4 13

Output

9 20 35 11 25

Note

In the first sample, Bob first makes a snow pile of volume 10, which melts to the size of 5 on the same day. On the second day, he makes another pile of size 10. Since it is a bit warmer than the day before, the first pile disappears completely while the second pile shrinks to 3. At the end of the second day, he has only a single pile of size 3. On the third day he makes a smaller pile than usual, but as the temperature dropped too, both piles survive till the end of the day.

 

题意:每天产生一堆体积为 Vi 的雪,然后给出当天的温度 Ti,如果一堆雪的体积 V > Ti,则此堆雪体积减少 Ti,反之,减少 V。最后问每一天总共融化的雪的体积。

思路:看大牛的思路看了好久才看明白。这里借鉴一下。因为 每第 i 堆雪是在第 i 天才产生的,也就是第 i 堆雪在第 i 天之前的体积都是 0 ,但是我们可以假设 所有堆的雪从第一天开始就是有体积的,但是他的体积是 sum[i-1] + v[i],(其中sum 数组是温度的前缀和),为什么要这样假设????。。。 对于第 i 堆雪,按照题是第 i 天才开始融化,但是这里我们假设了 从一开始 就有体积,也就是每一天 每一堆雪都要融化,   所以说对于 假设的第 i 堆雪的体积 为 sum[i-1] + v[i],到第 i - 1天时,第 i 堆的雪体积就是 v[i] 了。 然后对于一个 sum[i-1] + v[i] <= sum[i], 很显然,就是第 i 堆雪全部融化完了。

这里用 优先队列维护假设体积。

AC代码:

#include<bits/stdc++.h>
using namespace std;

const int maxn = 1e5 + 10;
int v[maxn];
int t[maxn];
long long sum[maxn];

int main()
{
    int n;
    while(~scanf("%d",&n)){
        for(int i = 1;i <= n;i ++)
            scanf("%d",&v[i]);
        for(int i = 1;i <= n;i ++)
            scanf("%d",&t[i]);
        memset(sum,0,sizeof(sum));
        for(int i = 1;i <= n;i ++)
            sum[i] = sum[i-1] + t[i];
        priority_queue<long long,vector<long long>,greater<long long> >Q;

        for(int i = 1;i <= n;i ++){
            long long ans = 0;
            Q.push(v[i] + sum[i-1]);
            while(!Q.empty() && Q.top() <= sum[i]){
                ans += Q.top() - sum[i-1];
                Q.pop();
            }
            ans += Q.size() * t[i];
            printf("%I64d ",ans);
        }
        printf("\n");
    }
    return 0;
}

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值